unsigned short mask(unsigned short num) {   //Funcin que retorna el equivalente
switch (num) {                              //en hexadecimal del nmero deseado
case 0 : return 0x3F;                       //para ser usado en la presentacin
case 1 : return 0x06;                       //para los displays de 7 segmentos
case 2 : return 0x5B;
case 3 : return 0x4F;
case 4 : return 0x66;
case 5 : return 0x6D;
case 6 : return 0x7D;
case 7 : return 0x07;
case 8 : return 0x7F;
case 9 : return 0x6F;
}
}
void inve(unsigned short pb) {    //Funcin para lograr la ubicacin
 unsigned int i,j=4;              //encendidos en orden
 PORTB=pb;
 i=PORTB.RB0;
 PORTB.RB0= PORTB.RB7;
 PORTB.RB7=i;
 i=PORTB.RB1;
 PORTB.RB1= PORTB.RB6;
 PORTB.RB6=i;
 i=PORTB.RB2;
 PORTB.RB2= PORTB.RB5;
 PORTB.RB5=i;
 i=PORTB.RB3;
 PORTB.RB3= PORTB.RB4;
 PORTB.RB4=i;
 }


//-----------------------------------------------------------------------
unsigned int temp_res,unidad=10,valor=0,band=0,valoru=0,valord=0;
signed int  tb=0,tv=0;    //Declaracin de las variables a usar

void main() {
  ANSEL  = 0x01;              //Se Configura el pin AN0 como seal anloga
  ANSELH = 0;                 //Se Configuran los otros pines como I/O digitales
  C1ON_bit = 0;               //Se desactivan los comparadores
  C2ON_bit = 0;

  TRISA  = 0xFF;              //PORTA configurado como entrada
  TRISB  = 0;                 //PORTB configurado como salida
  TRISC  = 0;                 //PORTC configurado como salida
  TRISD  = 0;                 //PORTD configurado como salida
  inicio:
  PORTB=0;     //Se cargan todas las variables con cero excepto unidad
  valoru=0;
  valord=0;
  band=0;
  valor=0;
  unidad=10;
  tb=0;
  tv=0;
  do{                                    //Se mantiene en este lazo de espera
     PORTC=0b01110111;                   //hasta seleccionar un ejercicio
     PORTD=0b01110001;
  }while(PORTA.RA1==0 && PORTA.RA2==0);
  
  if(PORTA.RA1==1){    //Se pregunta si se selecciono el ejercicio 1
  do {
    temp_res = ADC_Read(0); // Get 10-bit results of AD conversion
    PORTC = mask(valoru);   //Se carga en el PORTC el valor a mostrar en el display 1
    PORTD = mask(valord);   //Se carga en el PORTD el valor a mostrar en el display 2

    if(valor<=99 && (tb==valor || tv==valor))   {
       tb=valor+1;       //Se carga en tb el adyacente superior de valor
       tv=valor-1;       //Se carga en tb el adyacente inferior de valor
       inve(valor);      //Se invierte la informacin de valor
       }

    if(PORTA.RA3==1){   //Se pregunta si se desea volver al men
       goto  inicio;    //Salta a inicio
    }

    if(temp_res >= unidad){  //Pregunta si el valor presente del potenciometro
       unidad+=10;           //es mayor al obtenido anteriormente
       valor++;              //Se incrementa la variable valor
       band=temp_res;
       }
    if(temp_res<band){  //Pregunta si el valor presente del potenciometro
       unidad-=10;      //es menor al obtenido anteriormente
       valor--;         //Se decrementa la variable valor
       }
    if(valor<=99){
       valoru=valor%10;   //Se obtiene el valor para la unidad a ser mostrada
       valord=valor/10;   //Se obtiene el valor para la decena a ser mostrada
       }
  } while(1);
  }
  else {     //Si se selecciono el ejercicio 2 (JUEGO)
    PORTB=0X08;    //Se enciende el led del pin RB3
    do{
     while(PORTA.RA4==1 || PORTA.RA1==1){ //Se repite este lazo mientras una de
        if(PORTA.RA4==1){                 //las botoneras RA1 o RA4 esten
           if(valoru==10){                //presionadas
              valoru=0;}
        PORTC = mask(valoru);  //Se carga en el PORTC el valor a mostrar en el display 1
        valoru+=1;      //La variable valoru se incrementa en 1
        }
        if(PORTA.RA1==1){ //Se ejecuta si se encuentra presionada la botonera
           if(valord==10){//RA1
              valord=0;}
        PORTD = mask(valord); //Se carga en el PORTD el valor a mostrar en el display 2
        valord+=1;  //La variable valord se incrementa en 1
        }
        Delay_ms(20);  //Retardo de 20 milisegundos
        band=1;   //Se carga la variable band con 1
     }
     if(valoru>valord && band==1){
        PORTB=PORTB<<1;   //Se realiza un desplazamiento a la izquierda del
        band=0;           //PORTB
     }
    if(PORTA.RA3==1){     //Se pregunta si se desea volver al men
       goto  inicio;      //Se salta a inicio
    }
     if(valoru<valord && band==1){
        PORTB=PORTB>>1;   //Se realiza un desplazamiento a la derecha del
        band=0;           //PORTB
     }
     if(PORTB.RB7==1){     //Se ejecuta si se activa el pin RB7
       PORTD= 0x7D;    //Se muestra en el display 2 la letra G
       PORTC= 0x06;    //Se muestra en el display 1 el nmero 1
     }
     if(PORTB.RB0==1){  //Se ejecuta si se activa el pin RB0
       PORTD= 0x7D;  //Se muestra en el display 2 la letra G
       PORTC= 0x5B;  //Se muestra en el display 1 el nmero 2
     }
    }while(PORTB.RB0==0 && PORTB.RB7==0);//Se repite mientras no gane un jugador
    while(PORTA.RA3==0); //Espera a que el usuario decida volver al men
    goto  inicio; //Se salta a inicio
  }
}